class Block implements Shape {
  color dColor;
  int minXSize,minYSize,maxXSize,maxYSize;

  //Dot
  Block() {
    //defaults
    minXSize = 15;
    minYSize = 15;
    maxXSize = 25;
    maxYSize = 25;
  } //Dot

  //updateDraw
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {
    dColor = getDotColor();

    buffer.ellipseMode(LEFT);

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

    int dSize = min(dWidth, dHeight);

    if (showRects) {
      buffer.fill(120, 80, 0);
      buffer.stroke(0);
      buffer.rect(0, 0, dWidth, dHeight);
    }

    int horizPlay = dWidth - dSize;
    int vertPlay = dHeight - dSize;
    int targetX = int(random(horizPlay));
    int targetY = int(random(vertPlay));

    buffer.noStroke();
    buffer.fill(dColor);
    buffer.rect(targetX, targetY, dSize, dSize);

    buffer.popMatrix();
  } //updateDraw

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}
